// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package infoscreen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// InfoscreenClient is the client API for Infoscreen service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type InfoscreenClient interface {
	// ListInfoPages Return a list of all currently active info pages
	ListInfoPages(ctx context.Context, in *ListInfoRequest, opts ...grpc.CallOption) (Infoscreen_ListInfoPagesClient, error)
	// GetInfoPage Returns all data we have for an info page when given an id
	GetInfoPage(ctx context.Context, in *GetInfoPageRequest, opts ...grpc.CallOption) (*InfoPage, error)
	// CreateInfoPage Creates an infopage with the specified parameters
	CreateInfoPage(ctx context.Context, in *CreateInfoPageRequest, opts ...grpc.CallOption) (*Empty, error)
	// DeleteInfoPage Deletes an infopage when given an id
	DeleteInfoPage(ctx context.Context, in *DeleteInfoPageRequest, opts ...grpc.CallOption) (*Empty, error)
}

type infoscreenClient struct {
	cc grpc.ClientConnInterface
}

func NewInfoscreenClient(cc grpc.ClientConnInterface) InfoscreenClient {
	return &infoscreenClient{cc}
}

func (c *infoscreenClient) ListInfoPages(ctx context.Context, in *ListInfoRequest, opts ...grpc.CallOption) (Infoscreen_ListInfoPagesClient, error) {
	stream, err := c.cc.NewStream(ctx, &Infoscreen_ServiceDesc.Streams[0], "/vseth.vis.infoscreen.Infoscreen/ListInfoPages", opts...)
	if err != nil {
		return nil, err
	}
	x := &infoscreenListInfoPagesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Infoscreen_ListInfoPagesClient interface {
	Recv() (*InfoPageMeta, error)
	grpc.ClientStream
}

type infoscreenListInfoPagesClient struct {
	grpc.ClientStream
}

func (x *infoscreenListInfoPagesClient) Recv() (*InfoPageMeta, error) {
	m := new(InfoPageMeta)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *infoscreenClient) GetInfoPage(ctx context.Context, in *GetInfoPageRequest, opts ...grpc.CallOption) (*InfoPage, error) {
	out := new(InfoPage)
	err := c.cc.Invoke(ctx, "/vseth.vis.infoscreen.Infoscreen/GetInfoPage", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *infoscreenClient) CreateInfoPage(ctx context.Context, in *CreateInfoPageRequest, opts ...grpc.CallOption) (*Empty, error) {
	out := new(Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.infoscreen.Infoscreen/CreateInfoPage", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *infoscreenClient) DeleteInfoPage(ctx context.Context, in *DeleteInfoPageRequest, opts ...grpc.CallOption) (*Empty, error) {
	out := new(Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.infoscreen.Infoscreen/DeleteInfoPage", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// InfoscreenServer is the server API for Infoscreen service.
// All implementations must embed UnimplementedInfoscreenServer
// for forward compatibility
type InfoscreenServer interface {
	// ListInfoPages Return a list of all currently active info pages
	ListInfoPages(*ListInfoRequest, Infoscreen_ListInfoPagesServer) error
	// GetInfoPage Returns all data we have for an info page when given an id
	GetInfoPage(context.Context, *GetInfoPageRequest) (*InfoPage, error)
	// CreateInfoPage Creates an infopage with the specified parameters
	CreateInfoPage(context.Context, *CreateInfoPageRequest) (*Empty, error)
	// DeleteInfoPage Deletes an infopage when given an id
	DeleteInfoPage(context.Context, *DeleteInfoPageRequest) (*Empty, error)
	mustEmbedUnimplementedInfoscreenServer()
}

// UnimplementedInfoscreenServer must be embedded to have forward compatible implementations.
type UnimplementedInfoscreenServer struct {
}

func (UnimplementedInfoscreenServer) ListInfoPages(*ListInfoRequest, Infoscreen_ListInfoPagesServer) error {
	return status.Errorf(codes.Unimplemented, "method ListInfoPages not implemented")
}
func (UnimplementedInfoscreenServer) GetInfoPage(context.Context, *GetInfoPageRequest) (*InfoPage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetInfoPage not implemented")
}
func (UnimplementedInfoscreenServer) CreateInfoPage(context.Context, *CreateInfoPageRequest) (*Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateInfoPage not implemented")
}
func (UnimplementedInfoscreenServer) DeleteInfoPage(context.Context, *DeleteInfoPageRequest) (*Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteInfoPage not implemented")
}
func (UnimplementedInfoscreenServer) mustEmbedUnimplementedInfoscreenServer() {}

// UnsafeInfoscreenServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to InfoscreenServer will
// result in compilation errors.
type UnsafeInfoscreenServer interface {
	mustEmbedUnimplementedInfoscreenServer()
}

func RegisterInfoscreenServer(s grpc.ServiceRegistrar, srv InfoscreenServer) {
	s.RegisterService(&Infoscreen_ServiceDesc, srv)
}

func _Infoscreen_ListInfoPages_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(ListInfoRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(InfoscreenServer).ListInfoPages(m, &infoscreenListInfoPagesServer{stream})
}

type Infoscreen_ListInfoPagesServer interface {
	Send(*InfoPageMeta) error
	grpc.ServerStream
}

type infoscreenListInfoPagesServer struct {
	grpc.ServerStream
}

func (x *infoscreenListInfoPagesServer) Send(m *InfoPageMeta) error {
	return x.ServerStream.SendMsg(m)
}

func _Infoscreen_GetInfoPage_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetInfoPageRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(InfoscreenServer).GetInfoPage(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.infoscreen.Infoscreen/GetInfoPage",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(InfoscreenServer).GetInfoPage(ctx, req.(*GetInfoPageRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Infoscreen_CreateInfoPage_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateInfoPageRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(InfoscreenServer).CreateInfoPage(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.infoscreen.Infoscreen/CreateInfoPage",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(InfoscreenServer).CreateInfoPage(ctx, req.(*CreateInfoPageRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Infoscreen_DeleteInfoPage_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteInfoPageRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(InfoscreenServer).DeleteInfoPage(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.infoscreen.Infoscreen/DeleteInfoPage",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(InfoscreenServer).DeleteInfoPage(ctx, req.(*DeleteInfoPageRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Infoscreen_ServiceDesc is the grpc.ServiceDesc for Infoscreen service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Infoscreen_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.infoscreen.Infoscreen",
	HandlerType: (*InfoscreenServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetInfoPage",
			Handler:    _Infoscreen_GetInfoPage_Handler,
		},
		{
			MethodName: "CreateInfoPage",
			Handler:    _Infoscreen_CreateInfoPage_Handler,
		},
		{
			MethodName: "DeleteInfoPage",
			Handler:    _Infoscreen_DeleteInfoPage_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "ListInfoPages",
			Handler:       _Infoscreen_ListInfoPages_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "vseth/vis/infoscreen/infoscreen.proto",
}
